#ifndef _TIMER_H_
#  define _TIMER_H_ 1

#include "common.h"
#include "verbose.h"

/********************************/
/*  timer.c     -- Export list  */
/********************************/

extern char           * hrtimer_name;
extern unsigned long    hrtimer_resolution;

void          init_timer(  void );
void          start_timer( void );
unsigned long read_timer(  void );
char *        sprint_timer( unsigned long timer_val );
void          show_timer_resolution( void );


Ulong         sample_avg( Ulong * p_sample, size_t p_nelements );

/********************************/
/*  platform.c  -- Export list  */
/********************************/

void           sys_greeting( char * p_prefix,  struct sys_platform_s * p_pls );

void           sys_machine_speed( Ulong * dbg_speed, Ulong * opt_speed );

char *         sys_get_hostname( void );

#define BENCH_MEMSIZE        10000
#define PENTIUM90_SPEED_DBG   3560  /* for BENCH_MEMSIZE=10000, Win32-Debug,   V
isual C++ 5 */
#define PENTIUM90_SPEED_OPT   1854  /* for BENCH_MEMSIZE=10000, Win32-Release, V
isual C++ 5 */

extern float  perf_correction;

extern char * os_platform;

/********************************/
/*  md5.c -- Export list        */
/********************************/
typedef struct {
  Uint32        state[4];                           /* state (ABCD)    */
  Uint32        count[2];  /* number of bits, modulo 2^64 (lsb first)  */
  unsigned char buffer[64];                         /* input buffer    */
} haMD5_CTX;

void haMD5Init   ( haMD5_CTX * context );        /* in/out: context    */

void haMD5Update ( haMD5_CTX      * context,     /* in: context        */
                   unsigned char  * input,       /* in: inputBuffer    */
                   size_t           inputLen );  /* in: inputLen       */

void haMD5Final  ( unsigned char    digest[16],  /* in/out: MD5-digest */ 
                   haMD5_CTX        * context ); /* in:     context    */


#endif /* _TIMER_H_ */
